XPathExpression (Java Platform SE 8 )
Keywords: javax.xml.xpath.XPathExpression interface
Date: 2017-07-29

compact2, compact3
javax.xml.xpath

## Interface XPathExpression

-     public interface XPathExpression

  `XPathExpression` provides access to compiled XPath expressions.

  Evaluation of XPath Expressions.
  context | If a request is made to evaluate the expression in the absence of a context item, an empty document node will be used for the context. For the purposes of evaluating XPath expressions, a DocumentFragment is treated like a Document node.
  variables | If the expression contains a variable reference, its value will be found through the `XPathVariableResolver`. An `XPathExpressionException` is raised if the variable resolver is undefined or the resolver returns `null` for the variable. The value of a variable must be immutable through the course of any single evaluation.
  functions | If the expression contains a function reference, the function will be found through the `XPathFunctionResolver`. An `XPathExpressionException` is raised if the function resolver is undefined or the function resolver returns `null` for the function.
  QNames | QNames in the expression are resolved against the XPath namespace context.
  result | This result of evaluating an expression is converted to an instance of the desired return type. Valid return types are defined in `XPathConstants`. Conversion to the return type follows XPath conversion rules.

  An XPath expression is not thread-safe and not reentrant. In other words, it is the application's responsibility to make sure that one `XPathExpression` object is not used from more than one thread at any given time, and while the `evaluate` method is invoked, applications may not recursively call the `evaluate` method.

  Since:
    1.5
  See Also:
    XML Path Language (XPath) Version 1.0, Expressions

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `String` | `evaluate(InputSource source)` Evaluate the compiled XPath expression in the context of the specified `InputSource` and return the result as a `String`.
    `Object` | `evaluate(InputSource source, QName returnType)` Evaluate the compiled XPath expression in the context of the specified `InputSource` and return the result as the specified type.
    `String` | `evaluate(Object item)` Evaluate the compiled XPath expression in the specified context and return the result as a `String`.
    `Object` | `evaluate(Object item, QName returnType)` Evaluate the compiled XPath expression in the specified context and return the result as the specified type.

- - ### Method Detail

    - #### evaluate

          Object evaluate(Object item,
                          QName returnType)
                   throws XPathExpressionException

      Evaluate the compiled XPath expression in the specified context and return the result as the specified type.

      See Evaluation of XPath Expressions for context item evaluation, variable, function and QName resolution and return type conversion.

      If `returnType` is not one of the types defined in `XPathConstants`, then an `IllegalArgumentException` is thrown.

      If a `null` value is provided for `item`, an empty document will be used for the context. If `returnType` is `null`, then a `NullPointerException` is thrown.

      Parameters:
        `item` - The starting context (a node, for example).
        `returnType` - The desired return type.
      Returns:
        The `Object` that is the result of evaluating the expression and converting the result to `returnType`.
      Throws:
        `XPathExpressionException` - If the expression cannot be evaluated.
        `IllegalArgumentException` - If `returnType` is not one of the types defined in `XPathConstants`.
        `NullPointerException` - If `returnType` is `null`.

    - #### evaluate

          String evaluate(Object item)
                   throws XPathExpressionException

      Evaluate the compiled XPath expression in the specified context and return the result as a `String`.

      This method calls `evaluate(Object item, QName returnType)` with a `returnType` of `XPathConstants.STRING`.

      See Evaluation of XPath Expressions for context item evaluation, variable, function and QName resolution and return type conversion.

      If a `null` value is provided for `item`, an empty document will be used for the context.

      Parameters:
        `item` - The starting context (a node, for example).
      Returns:
        The `String` that is the result of evaluating the expression and converting the result to a `String`.
      Throws:
        `XPathExpressionException` - If the expression cannot be evaluated.

    - #### evaluate

          Object evaluate(InputSource source,
                          QName returnType)
                   throws XPathExpressionException

      Evaluate the compiled XPath expression in the context of the specified `InputSource` and return the result as the specified type.

      This method builds a data model for the `InputSource` and calls `evaluate(Object item, QName returnType)` on the resulting document object.

      See Evaluation of XPath Expressions for context item evaluation, variable, function and QName resolution and return type conversion.

      If `returnType` is not one of the types defined in `XPathConstants`, then an `IllegalArgumentException` is thrown.

      If `source` or `returnType` is `null`, then a `NullPointerException` is thrown.

      Parameters:
        `source` - The `InputSource` of the document to evaluate over.
        `returnType` - The desired return type.
      Returns:
        The `Object` that is the result of evaluating the expression and converting the result to `returnType`.
      Throws:
        `XPathExpressionException` - If the expression cannot be evaluated.
        `IllegalArgumentException` - If `returnType` is not one of the types defined in `XPathConstants`.
        `NullPointerException` - If `source` or `returnType` is `null`.

    - #### evaluate

          String evaluate(InputSource source)
                   throws XPathExpressionException

      Evaluate the compiled XPath expression in the context of the specified `InputSource` and return the result as a `String`.

      This method calls `evaluate(InputSource source, QName returnType)` with a `returnType` of `XPathConstants.STRING`.

      See Evaluation of XPath Expressions for context item evaluation, variable, function and QName resolution and return type conversion.

      If `source` is `null`, then a `NullPointerException` is thrown.

      Parameters:
        `source` - The `InputSource` of the document to evaluate over.
      Returns:
        The `String` that is the result of evaluating the expression and converting the result to a `String`.
      Throws:
        `XPathExpressionException` - If the expression cannot be evaluated.
        `NullPointerException` - If `source` is `null`.

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.
Copyright © 1993, 2017, Oracle and/or its affiliates. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.